package com.fp.persistence.pfirmas.param;

import javax.persistence.EmbeddedId;
import javax.persistence.Entity;
import javax.persistence.Column;
import javax.persistence.EntityManager;
import java.io.Serializable;
import javax.persistence.Table;
import com.fp.dto.hb.HibernateBean;
import java.lang.reflect.Field;
import javax.persistence.Transient;
import java.sql.Date;

/**Clase que implementa la entidad de Hibernate que hace referencia a la tabla TFIRMCERTIFICADO*/
@Entity(name="TfirmCertificado")
@Table(name="TFIRMCERTIFICADO")
public class TfirmCertificado extends com.fp.dto.AbstractDataTransport implements Serializable,HibernateBean,Cloneable{
/**
* HashCode asociado con la Instancia
*/
@Transient
private int hashValue = 0;
/**
* Version de la Clase
*/
private static final long serialVersionUID = 1L;
/**
* Clave primaria de la Entidad TfirmCertificado
*/
@EmbeddedId
private TfirmCertificadoKey pk;
@Column(name="FVIGENCIA", nullable=false)

/**
* Fecha de vigencia del certificado.
*/
private Date fvigencia;

@Column(name="FINGRESO", nullable=false)

/**
* Fecha de creacion del registro.
*/
private Date fingreso;

@Column(name="CODIGOUSUARIO", nullable=true)

/**
* Codigo de usuario al que se asocia el certificado.
*/
private String codigousuario;

@Column(name="CARGO", nullable=true)

/**
* Nombre del cargo asociado al usuario
*/
private String cargo;

/**Contructor por defecto*/
public TfirmCertificado(){
}
/**Contructor de TfirmCertificado
@param pPk Clave Primaria del entity
@param pFvigencia Fecha de vigencia del certificado.
@param pFingreso Fecha de creacion del registro.
*/
public TfirmCertificado(TfirmCertificadoKey pPk,Date pFvigencia,Date pFingreso){
 this();
 pk=pPk;
 fvigencia=pFvigencia;
 fingreso=pFingreso;
}
/**
* Metodo que entrega datos de la tabla dada la clave primaria.
* @param pEntityManager referencia de la session a obtener datos del bean.
* @param pKey Caleve primaria del bean.
* @return TfirmCertificado
*/
public static TfirmCertificado find(EntityManager pEntityManager,TfirmCertificadoKey pKey) throws Exception{
    TfirmCertificado obj = pEntityManager.find(TfirmCertificado.class,pKey);
    return obj;
}
/**Entrega la Clave primaria de TfirmCertificado
@return El objeto que referencia a la Clave primaria de TfirmCertificado
*/
public TfirmCertificadoKey getPk(){
  return pk;
}
/**Fija un nuevo valor a la Clave primaria de TfirmCertificado
@param pPk El objeto que referencia a la nueva Clave primaria de TfirmCertificado
*/
public void setPk(TfirmCertificadoKey pPk){
  pk=pPk;
}
/**Obtiene el valor de fvigencia
@return valor de fvigencia*/
public Date getFvigencia(){
  return fvigencia;
}
/**Fija el valor de fvigencia
@param pFvigencia nuevo Valor de fvigencia*/
public void setFvigencia(Date pFvigencia){
  fvigencia=pFvigencia;
}

/**Obtiene el valor de fingreso
@return valor de fingreso*/
public Date getFingreso(){
  return fingreso;
}
/**Fija el valor de fingreso
@param pFingreso nuevo Valor de fingreso*/
public void setFingreso(Date pFingreso){
  fingreso=pFingreso;
}

/**Obtiene el valor de codigousuario
@return valor de codigousuario*/
public String getCodigousuario(){
  return codigousuario;
}
/**Fija el valor de codigousuario
@param pCodigousuario nuevo Valor de codigousuario*/
public void setCodigousuario(String pCodigousuario){
  codigousuario=pCodigousuario;
}

/**Obtiene el valor de cargo
@return valor de cargo*/
public String getCargo(){
  return cargo;
}
/**Fija el valor de cargo
@param pCargo nuevo Valor de cargo*/
public void setCargo(String pCargo){
  cargo=pCargo;
}

public boolean equals(Object rhs){
    if (rhs == null)return false;
    if (! (rhs instanceof TfirmCertificado))return false;
    TfirmCertificado that = (TfirmCertificado) rhs;
    if (this.getPk() == null || that.getPk() == null)
        return false;
    return (this.getPk().equals(that.getPk()));
}
/**Implementacion del metodo hashCode de la la entidad TfirmCertificado
@return el hashCode la instancia
*/
public int hashCode()    {
    if (this.hashValue == 0){
        int result = 17;
        if (this.getPk() == null){
            result = super.hashCode();
        }else{
            result = this.getPk().hashCode();
        }
        this.hashValue = result;
    }
    return this.hashValue;
}
/**Implementacion toString
*/
public String toString() {
	Field[]fs=this.getClass().getDeclaredFields();
	String data="";
	for(Field f:fs){
	 try{	
	 String name=f.getName();
   if(f.getType().getName().compareTo("java.util.Set")==0)continue;
	 if(name.compareTo("hashValue")==0||name.compareTo("serialVersionUID")==0)continue;
		data+=name+"="+f.get(this)+";";
	 }catch(Exception e){
		 continue;
	 }
		}
		if(data.compareTo("")==0){
		data=super.toString();
		}
	return data;
	}
/**Implementacion de la creacion de un bean en blanco TfirmCertificado
*/
public Object createInstance(){
 TfirmCertificado instance=new TfirmCertificado();	
 instance.setPk(new TfirmCertificadoKey());
 return instance;
}
/**Clona la entidad TfirmCertificado
@see com.fp.dto.hb.HibernateBean#cloneMe()
*/
public Object cloneMe() throws CloneNotSupportedException{
  TfirmCertificado p=(TfirmCertificado)this.clone();
  p.setPk((TfirmCertificadoKey)this.pk.cloneMe());
  return p;
}
}
